function createPriorityQueue(cmp) {
    const _tree = [null];
    let _size = 0;
    function enqueue(val) {
        _tree[++_size] = val;
        _up(_size);
    }
    function dequeue() {
        if (_size < 1)
            return undefined;
        const target = _tree[1];
        _tree[1] = _tree[_size--];
        _down(1);
        return target;
    }
    function top() {
        return _size > 0 ? _tree[1] : undefined;
    }
    function collect() {
        return _tree.slice(1);
    }
    function _down(index) {
        for (let i = index; i <= _size;) {
            const lft = i << 1;
            const rht = lft | 1;
            if (lft > _size)
                break;
            let q = lft;
            if (rht <= _size && cmp(_tree[rht], _tree[q]) > 0)
                q += 1;
            const x = _tree[q];
            if (cmp(_tree[i], x) >= 0)
                break;
            _tree[q] = _tree[i];
            _tree[i] = x;
            i = q;
        }
    }
    function _up(index) {
        for (let i = index; i > 1;) {
            const q = i >> 1;
            const x = _tree[q];
            if (cmp(x, _tree[i]) >= 0)
                break;
            _tree[q] = _tree[i];
            _tree[i] = x;
            i = q;
        }
    }
    return {
        enqueue,
        dequeue,
        top,
        collect,
        size: () => _size,
        isEmpty: () => _size < 1,
    };
}

export { createPriorityQueue };
